/******************************************************
 *File: suspension.h
 *Author: Henrik Hedman
 *Created: 2004-11-10
 *Modified: 2004-12-10
 *Description: Suspension of the wheels.
 *						 Recieves a length of the spring and 
 *						 calculates the force done by the spring	
 *****************************************************/
#ifndef SUSPENSION_H
#define SUSPENSION_H

using namespace std;

namespace suspension {

	class Suspension {
   
		public:
		Suspension( double );
    	double calculateSpringForce( double, double );


		private:
	  	double orgLength;
	  	double force;
	  	double oldLength;
	
			/***********
    	 * Constant variables
    	 **********/  
 			static double const SPRINGKOEFFICIENT = 1 / 0.000004;
 			static double const DAMPER = 20000;
  };
}
#endif //SUSPENSION_H
