/*******************************************
 *File: turret.h
 *Author: Jonas Hellsten
 *Created: 2004-12-12
 *Description: Simulates the turret of a tank
 *
 ******************************************/

#ifdef WIN32
#include "irrlicht.h"
#endif // WIN32
#ifdef linux
#include "irrlicht/irrlicht.h"
#endif // Linux

#ifndef TURRET_H
#define TURRET_H

#include <vector>

using namespace std;
using namespace irr;
using namespace core;

namespace turret{

  class Turret{

    
  public:
    Turret();
    Turret(IrrlichtDevice* device, scene::ISceneNode* chassi2);
    ~Turret();
  //Functions
    void rotateRight(bool rotateRight);
 	void rotateLeft(bool rotateLeft);
	void elevate(bool elevate);
	void dump(bool dump);
	void shoot(bool shoot);
	void calculate(float frameTime);
    
  private:
	//variables
	float angularVelocity;
	scene::ISceneNode* chassi;
	scene::ISceneNode* turret;
	scene::ISceneNode* canonNode;
    scene::ISceneNode* canon;
	
	
	bool rotatingRight;
	bool rotatingLeft;
	bool elevating;
	bool dumping;
	bool shooting;
	float shootStrength;
	
	
   	//constants 
        static const float I = 381250/10;
	static const float MOMENT = 28000000;
	static const float ELEVATIONLIMIT= -20;
	static const float DUMPLIMIT= 10;
	static const float ELEVATIONSPEED = 20;

  };

} //end of namespace engine

#endif //TURRET_H

